<template>
  <div class="obligatory">
    <div class="obligatory_nome" @click="toggleShow()">
      <fa
        icon="angle-right" 
        class="trilha_nome_icone"
        :class="{trilha_nome_icone_focado : this.focado}"
      />
      <div class="obligatory_nome_texto"> Obrigatórias </div>
    </div>

    <transition name="fade">
      <div class="obligatory_container" v-if="this.focado">
        <disciplina v-for="disciplina of obligatories"
            v-if="disciplina.id_disciplina !== null"
            :key="disciplina.codigo_disciplina"
            :code="disciplina.codigo_disciplina"
            :creditos="`${disciplina.creditos_aula + disciplina.creditos_trabalho}`"
        />
      </div>
    </transition>
  </div>
</template>

<script>
import Disciplina from "@/components/Disciplina.vue";
import { mapGetters } from "vuex";

export default {
  props: ["obligatories"],

  components: {
    Disciplina
  },

  data() {
    return {
      focado: false
    };
  },

  methods: {
    toggleShow() {
      this.focado = !this.focado;
    },

    determineStatus(codigo) {
      const approvedSubjects = this.getApprovedSubjects;

      if (approvedSubjects.includes(codigo)) return "cursada";
      return "nulo";
    }
  },

  computed: {
    ...mapGetters(["getApprovedSubjects"])
  }
};
</script>

<style lang="scss">
.obligatory {
  margin: 1em;
  color: $primary-color;
}

.obligatory_container {
  display: flex;
  flex-flow: row nowrap;

  width: 100%;

  border-radius: 0.5em;
  background: $light-color;
}

.fade-enter-active,
.fade-leave-active {
  opacity: 1;
  transition: opacity 0.3s ease;
}

.fade-enter,
.fade-leave-to {
  opacity: 0;
}

.obligatory_nome {
  display: flex;
  flex-flow: row nowrap;
  justify-content: flex-start;
  align-items: center;

  padding: 0 0 0.5em 1em;

  font-size: 20px;

  user-select: none;
  cursor: pointer;
}

.obligatory_nome_texto {
  padding: 0.1em 0 0 0.3em;
  align-self: flex-end;
}

.obligatory_nome_icone {
  transition: transform 0.3s ease-in-out;
}

.obligatory_nome_icone_focado {
  transform: rotate(90deg);
}
</style>
